$regfile = "m8def.dat"
$crystal = 8000000

Config Lcd = 20 * 4
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portd.7 , Db6 = Portd.6 , Db7 = Portd.5 , E = Portb.7 , Rs = Portb.6
Config Watchdog = 2048
Config Adc = Single , Prescaler = Auto , Reference = Internal
Config Timer0 = Timer , Prescale = 1024
Stop Timer0
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Config Timer2 = Pwm , Prescale = 1 , Compare = Set , Pwm = On , Compare Pwm = Clear Up


Config Debounce = 30
Config Int0 = Rising
Config Int1 = Falling

On Timer0 Odmierz_1s
On Int0 Up
On Int1 Down






Config Pind.0 = Input                                       'Rs 232 RXD
Config Pind.1 = Output                                      'Rs 232 TXD
Config Pind.2 = Input                                       'INT0
Config Pind.3 = Input                                       'INT1
Config Pind.4 = Output                                      'PD4 wolny pin   podpieto buzzer
Config Pinb.1 = Input                                       'UP
Config Pinb.2 = Input                                       'Down
Config Pinb.3 = Output                                      ' OCR2 ---- PWM Timer2
Config Pinb.4 = Input                                       ' wolny
Config Pinb.5 = Input                                       'Enter
'Config Pinc.0 = Input                                       'ADC0
'Config Pinc.1 = Input                                       'ADC1
'Config Pinc.2 = Input                                       'adc2
'Config Pinc.3 = Input                                       'ADC3
'Config Sda = Portc.4                                        ' i2c SDA
'Config Scl = Portc.5                                        'I2C SCL
'Config I2cdelay = 20

'===================================================================================================================

Dim Sekundy As Byte                                         'zmienna zliczajca sekundy
Dim Minuty As Byte                                          'zmienna zliczajca minuty
Dim Godziny As Byte
Dim Przep As Byte
Dim Exit_loop As Bit
Dim Menu As Integer
Dim Batt As Integer                                         'moitor  napiecia baterii  z adc3  8bit 1024
Dim Batt_volt As Single , Batt_volt_avg As Single , Batt_volt_lcd As String * 4       ' konwersja 1024 na zmienno-przecinkowa  , formatowanie dla LCD
Dim Current As Integer , Current_amp As Single , Current_avg As Single , Current_amp_lcd As String * 4 , Total_current As Single       'konwersja 1024 ...
Dim I As Byte
Dim I_poprawka As Single , U_poprawka As Single , I_poprawka_e As Eram Single , U_poprawka_e As Eram Single
Dim Watt As Single
Dim Total_time As Single
Dim Prad_1(60) As Integer , Prad_sum As Single , Flaga_prad As Bit
Dim Im_kolo As Integer , Km As Single , Km_h As Single      ' impuls
'Dim S_1 As Byte
'==========================================================================================
Dim Czas_hi As Word , Czas_low As Word
Dim N As Bit                                                ' n=1 forward , n=0 backward
Dim N1 As Byte
Dim A As Byte
Dim I_1 As Byte                                             ' licznik obrotow
Dim Time_max As Long                                        ' software timer do wylaczenia silnikajezelinie pedalujemy
Dim Pwm As Byte
Dim Level As Byte
Dim P_1 As Byte , P_2 As Byte , P_3 As Byte , P_4 As Byte , P_5 As Byte , P_6 As Byte
Dim P_2_e As Eram Byte , P_3_e As Eram Byte , P_4_e As Eram Byte , P_5_e As Eram Byte
Dim Nr As Byte
Dim Pass_del As Byte , Pass_del_e As Eram Byte , Nr_1 As Byte
Dim Low_batt_l As Single , Low_batt_l_e As Eram Single , U_b As Single




'==============================================================================================================
Declare Sub Menu_1
Declare Sub Up_sub
Declare Sub Down_sub
Declare Sub Enter_sub
Declare Sub Voltomierz
Declare Sub Lcd_show
Declare Sub I_pop
Declare Sub U_pop
Declare Sub Up_sub_t
Declare Sub Down_sub_t
Declare Sub Enter_sub_t

Declare Sub Watomierz
Declare Sub Pass_level
Declare Sub Pass_delay
Declare Sub 3button
Declare Sub 3_butt_t
Declare Sub Lcd_3_key
Declare Sub Pipek
Declare Sub Low_batt



'==============================================================================================================
'Deflcdchar 0 , 4 , 4 , 4 , 4 , 21 , 21 , 14 , 4             ' strzalka w dol
'Deflcdchar 1 , 4 , 14 , 21 , 21 , 4 , 4 , 4 , 4             ' stzralka UP


'==============================================================================================================

S1 Alias Pinb.1                                             'UP
S2 Alias Pinb.2                                             'Down
S3 Alias Pinb.5                                             'Enter
Set Portb.1
Set Portb.2
Set Portb.5
'Set Portd.2

'============================================================================================================






Total_time = 0.001
Sekundy = 0
Minuty = 0
Godziny = 0
Przep = 0

I_poprawka = I_poprawka_e
'I_poprawka_e = 0.024

U_poprawka = U_poprawka_e
'U_poprawka_e = 2.465

Total_current = 0
Flaga_prad = 0
Prad_sum = 0

Time_max = 0
Level = 1
P_1 = 10
P_6 = 190
P_2 = P_2_e
P_3 = P_3_e
P_4 = P_4_e
P_5 = P_5_e
Pass_del = Pass_del_e

Exit_loop = 1
Menu = 1
Nr = 20
Nr_1 = 10
U_b = Low_batt_l_e
Low_batt_l = Low_batt_l_e

Enable Interrupts
Enable Timer0
Start Timer0
Start Adc
Enable Int0
Enable Int1

Ocr2 = 0



 Call Pipek

Waitms 500

Cls
Cursor Off
Locate 1 , 1
Lcd "Bike Cycle Analyst"
Locate 2 , 1
Lcd "Config press menu"

Wait 2

If S3 = 0 Then
Call Pipek
Wait 1
Call Menu_1
End If

Cls


Do
 Time_max = Time_max + 1


Locate 1 , 10
Lcd ; Godziny ; ":" ; Minuty ; ":" ; Sekundy

'Debounce Pinb.5 , 0 , Menu_1 , Sub
Debounce Pinb.1 , 0 , Up_sub , Sub
Debounce Pinb.2 , 0 , Down_sub , Sub


Call Lcd_show
Locate 4 , 10
Lcd "L= " ; Level

'======================= PAS ====================================
  If N = 1 And N1 >= 2 Then
   ' Reset Watchdog
     Ocr2 = Pwm

     Locate 4 , 1
     Lcd "PAS-ON "
     N1 = 0
    Reset Watchdog
    Time_max = 0
  End If

 If Time_max >= Pass_del Then                               ' to wylacza silniki po przekroczeniu 100 wykoniani petli do
    Time_max = 0
     Ocr2 = 0
    Locate 4 , 1
    Lcd "PAS-OFF"
    N = 0
    N1 = 0
 End If

 If N = 0 Then

     N1 = 0
 End If
'=========== koniec  PAS  ===========================
'===========      PAS level            ===========================
'========== usawienia poziomu PWM z level ====================

If Level = 1 Then
Pwm = P_1
End If

If Level = 2 Then
Pwm = P_2
End If

If Level = 3 Then
Pwm = P_3
End If

If Level = 4 Then
Pwm = P_4
End If

If Level = 5 Then
Pwm = P_5
End If

If Level = 6 Then
Pwm = P_6
End If

'===================================================================

 Reset Watchdog







 Loop






'*************************************MENU *************** ******************

Sub Menu_1
Cls

Do
Locate 4 , 1
Lcd "      " ; ; "   Enter"
Locate 1 , 1
Select Case Menu
Case Is = 1
Locate 2 , 1
Lcd "                    "
Locate 2 , 1
Lcd "SET I-POP =" ; Fusing(i_poprawka , "##.###")
Case Is = 2
Locate 2 , 1
Lcd "                    "
Locate 2 , 1
Lcd "SET U-POP =" ; Fusing(u_poprawka , "##.##")

Case Is = 3
Locate 2 , 1
Lcd "                    "
Locate 2 , 1
Lcd "SET PASS LEVEL" ;



Case Is = 4
Locate 2 , 1
Lcd "                    "
Locate 2 , 1
Lcd "PASS DELAY=" ; Pass_del

Case Is = 5
Locate 2 , 1
Lcd "                "
Locate 2 , 4
Lcd "BATT LOW LEVEL"

Case Is = 6
Locate 2 , 1
Lcd "                    "
Locate 2 , 4
Lcd "EXIT"



End Select




Debounce Pinb.1 , 0 , Up_sub , Sub
Debounce Pinb.2 , 0 , Down_sub , Sub
Debounce Pinb.5 , 0 , Enter_sub , Sub



If Exit_loop = 0 Then
Exit Do

 End If


Loop
Exit_loop = 1
Cls

End Sub

'**************** UP ************************************
Sub Up_sub
 Call Pipek
Incr Menu
Incr Level
Incr U_b
Nr = Nr + 10
Incr Nr_1
If Menu > 6 Then
Menu = 1
End If
If Level >= 6 Then
Level = 6

End If

If U_b >= 60 Then
U_b = 60
End If
If Nr_1 >= 20 Then
Nr_1 = 20
End If
If Nr >= 240 Then
Nr = 240
End If

End Sub

'************************* Down ****************
Sub Down_sub
 Call Pipek
Decr Menu
Decr Level
Decr Nr_1
Decr U_b
Nr = Nr - 10
If Menu < 1 Then
Menu = 6
End If

If U_b <= 20 Then
U_b = 20
End If

If Level <= 1 Then
Level = 1
End If

If Nr <= 20 Then
Nr = 20
End If

If Nr_1 <= 1 Then
Nr_1 = 1
End If


End Sub





'******************* Enter ****************************
Sub Enter_sub

If Menu = 1 Then
Call I_pop

End If
If Menu = 2 Then
Call U_pop
End If

If Menu = 3 Then
Call Pass_level
End If

If Menu = 4 Then
Call Pass_delay

End If

If Menu = 5 Then
Call Low_batt
End If





If Menu = 6 Then
 Call Enter_sub_t
End If



End Sub


'*****************Voltomierz*************************

Sub Voltomierz


Batt = Getadc(0)
Current = Getadc(1)                                         'monitor baterii   Adc3

 Batt_volt = Batt / 1024
 Batt_volt = Batt_volt * 2.56
 Batt_volt = Batt_volt * 28.44                              'U_poprawka  '28.44                              ' starta 27.82




Current_amp = Current / 1024
Current_amp = Current_amp * 2.56
Current_amp = Current_amp * 2.0246

Current_amp = Current_amp - U_poprawka                      '  2.465
Current_amp = Current_amp / I_poprawka                      ' 0.024



End Sub


'================================== Lcd_show========================================
Sub Lcd_show
Batt_volt_avg = 0
Current_avg = 0

For I = 1 To 30
Call Voltomierz

Current_avg = Current_avg + Current_amp
Batt_volt_avg = Batt_volt_avg + Batt_volt
Next I

Current_amp = Current_avg / 30
Batt_volt = Batt_volt_avg / 30
Watt = Current_amp * Batt_volt

Current_amp_lcd = Fusing(current_amp , "##.#")
Batt_volt_lcd = Fusing(batt_volt , "##.#")


Locate 1 , 1
Lcd "     "
Locate 1 , 1
Lcd Batt_volt_lcd ; " V "

Locate 2 , 1
Lcd "     "
Locate 2 , 1
Lcd Current_amp_lcd ; " A "
Locate 2 , 9
Lcd "            "
Locate 2 , 9
Lcd Fusing(watt , "####.") ; " W"


If Batt_volt <= Low_batt_l Then

Locate 3 , 15
Lcd "     "
Locate 3 , 15
Lcd "ALARM"
Call Pipek
End If



If Flaga_prad = 1 Then
Call Watomierz
End If

End Sub


'=====================================I_sub u_sub  ===================================================
Sub I_pop


I_poprawka = I_poprawka_e
Exit_loop = 1

Cls
Do

Locate 1 , 2

Lcd "I_pop="
Locate 1 , 9
Lcd "           "
Locate 1 , 9
Lcd Fusing(i_poprawka , "##.###")

Locate 2 , 3
Lcd "-     +    OK"


Call 3_butt_t


If Exit_loop = 0 Then
Exit Do
End If


Loop
 Exit_loop = 1
I_poprawka_e = I_poprawka
Waitms 45


End Sub










Sub U_pop


U_poprawka = U_poprawka_e


If U_poprawka >= 30 Then
  U_poprawka = 2.465
End If

If U_poprawka <= 0 Then
  U_poprawka = 2.465
End If

Exit_loop = 1

Cls
Do

Locate 1 , 2

Lcd "U_pop="
Locate 1 , 9
Lcd "           "
Locate 1 , 9
Lcd Fusing(u_poprawka , "##.###")

Call Lcd_3_key

Call 3_butt_t


If Exit_loop = 0 Then
Exit Do
End If


Loop
 Exit_loop = 1
U_poprawka_e = U_poprawka

Waitms 45


End Sub

'============================ Enter_sub_t Up_sub_t Down_sub_t   ========================================

Sub Enter_sub_t

Exit_loop = 0
Call Pipek

Cls
End Sub



Sub Up_sub_t
I_poprawka = I_poprawka + 0.001
If I_poprawka > 4 Then
I_poprawka = 4
End If

U_poprawka = U_poprawka + 0.01
If U_poprawka > 30 Then
U_poprawka = 30
End If



End Sub

Sub Down_sub_t
I_poprawka = I_poprawka - 0.001
If I_poprawka < 0 Then
I_poprawka = 0
End If

U_poprawka = U_poprawka - 0.01
If U_poprawka < 0 Then
U_poprawka = 0
End If


End Sub






'==========  Watomierz ========================
Sub Watomierz
Total_current = Total_current * 60

For I = 1 To 60

Prad_sum = Prad_sum + Prad_1(i)
Next I

Prad_sum = Prad_sum / 60
Prad_sum = Prad_sum / 1024
Prad_sum = Prad_sum * 2.56
Prad_sum = Prad_sum * 2.0246

Prad_sum = Prad_sum - U_poprawka                            ' 2.4685

Prad_sum = Prad_sum / I_poprawka


Total_current = Total_current + Prad_sum
Total_current = Total_current / 60

Locate 3 , 2
Lcd "           "
Locate 3 , 2
Lcd Fusing(total_current , "####.###") ; " Ah"



Flaga_prad = 0
Prad_sum = 0

End Sub


'================== pass level menu ====================================
Sub Pass_level

P_2 = P_2_e
Nr = P_2



Exit_loop = 1

Cls
Do


Locate 1 , 11
Lcd "   "
Locate 1 , 3
Lcd "Level 2=" ; P_2



Call Lcd_3_key
Call 3button
P_2 = Nr
If Exit_loop = 0 Then
Exit Do
End If
Loop
Exit_loop = 1

P_3 = P_3_e
Nr = P_3
Do

Locate 1 , 11
Lcd "   "
Locate 1 , 3
Lcd "Level 3=" ; P_3
Waitms 60
Call Lcd_3_key
Call 3button
P_3 = Nr
If Exit_loop = 0 Then
Exit Do
End If
Loop
Exit_loop = 1

P_4 = P_4_e
Nr = P_4
Do


Locate 1 , 11
Lcd "   "
Locate 1 , 3
Lcd "Level 4=" ; P_4
Waitms 60
Call Lcd_3_key
Call 3button
P_4 = Nr
If Exit_loop = 0 Then
Exit Do
End If
Loop
Exit_loop = 1

P_5 = P_5_e
Nr = P_5
Do

Locate 1 , 11
Lcd "   "
Locate 1 , 3
Lcd "Level 5=" ; P_5
Waitms 60
Call Lcd_3_key
Call 3button
P_5 = Nr
If Exit_loop = 0 Then
Exit Do
End If
Loop

Exit_loop = 1

P_2_e = P_2
P_3_e = P_3
P_4_e = P_4
P_5_e = P_5

End Sub

'===================== pass delay =======================

Sub Pass_delay
Pass_del = Pass_del_e
If Pass_del > 20 Then
Pass_del = 20
End If

Nr_1 = Pass_del

Cls
Do
Locate 1 , 13
Lcd "    "
Locate 1 , 3
Lcd "PASS DELAY=" ; Pass_del
Waitms 60

Locate 3 , 3
Lcd "-     +    OK"
Call 3button
Pass_del = Nr_1
If Exit_loop = 0 Then
Exit Do
End If
Loop

Exit_loop = 1
Pass_del_e = Pass_del
Waitms 45

End Sub


Sub 3button
Debounce Pinb.1 , 0 , Up_sub , Sub
Debounce Pinb.2 , 0 , Down_sub , Sub
Debounce Pinb.5 , 0 , Enter_sub_t , Sub

End Sub

Sub 3_butt_t
Debounce Pinb.1 , 0 , Up_sub_t , Sub
Debounce Pinb.2 , 0 , Down_sub_t , Sub
Debounce Pinb.5 , 0 , Enter_sub_t , Sub

End Sub


Sub Lcd_3_key

 Locate 3 , 3
Lcd "-     +    OK"
End Sub

Sub Pipek
Sound Portd.4 , 300 , 150

End Sub
'===========================================================
Sub Low_batt

Low_batt_l = Low_batt_l_e
U_b = Low_batt_l
Exit_loop = 1
If U_b <= 20 Then
U_b = 20
End If

Cls
Do

Locate 1 , 11
Lcd "   "
Locate 1 , 3
Lcd "LOW LEVEL=" ; Low_batt_l

Call Lcd_3_key
Call 3button
Low_batt_l = U_b
If Exit_loop = 0 Then
Exit Do
End If
Loop
Exit_loop = 1

Low_batt_l_e = Low_batt_l
Waitms 60

End Sub

'========================== Przerwania  =============================
'=====================================================================

Odmierz_1s:

 Stop Timer0

 Incr Przep
   If Przep >= 31 Then
     Incr Sekundy

      Przep = 0
      Prad_1(sekundy) = Getadc(1)
    End If


  If Sekundy >= 60 Then
   Sekundy = 0
    Flaga_prad = 1
   Incr Minuty

     If Minuty >= 60 Then
      Minuty = 0

      Incr Godziny

   If Godziny >= 24 Then
    Godziny = 0
     End If
    End If
  End If

 Sekundy = Sekundy
 Minuty = Minuty
 Godziny = Godziny


 Start Timer0
Return

Up:
Stop Timer1
Reset Watchdog
Czas_low = Timer1
Timer1 = 0
Czas_hi = 0
 Start Timer1
Reset Watchdog
 Return
'============================================================
Down:
Stop Timer1
Reset Watchdog
Czas_hi = Timer1
Timer1 = 0
If Czas_hi < Czas_low Then
N = 1
N1 = N1 + 1
End If
If Czas_hi > Czas_low Then
N = 0
N1 = 0
End If


Czas_low = 0
Start Timer1
Reset Watchdog
Return

